#ifndef __INTP_H__
#define __INTP_H__
#include "common.h"
#include "gpio.h"
#define KEY_WAITTIME                    (1U)   /* change the waiting time according to the system */


#define INTP0     0x01
#define INTP1     0x02
#define INTP2     0x04
#define INTP3     0x08
#define INTP4     0x10
#define INTP5     0x20
#define INTP6     0x40
#define INTP7     0x80

#define IS_INTP_TYPE(INTP) (((INTP) == INTP0)||((INTP) == INTP1)||((INTP) == INTP2)||((INTP) == INTP3)\
														||((INTP) == INTP4)||((INTP) == INTP5)||((INTP) == INTP6)||((INTP) == INTP7))



typedef enum
{
	Trigger_None,
	Trigger_Falling ,
	Trigger_Rising ,	
	Trigger_Rising_Falling
}Trigger_TypeDef;

typedef enum
{
	INTP0_GPIO,								/*!< Select INTP0 use as interrupt 0 input */
	INTP0_RXD0 								/*!< Select RXD0 use as interrupt 0 input */
}INTP0_InputDef;

typedef struct
{
	uint8_t INTP_Select;     					/*!< Specifies the trigger signal active edge for the EXTI lines.
                                         This parameter can be a value of @ref Trigger_TypeDef */
	
	Trigger_TypeDef EXTI_Trigger; 		/*!< Specifies the trigger signal active edge for the EXTI lines.
                                         This parameter can be a value of @ref Trigger_TypeDef */
	
	INTP0_InputDef INTP0_Port; 		/*!< Specifies the input port of INTP0.
                                         This parameter can be a value of @ref INTP0_InputDef */	
}INTP_InitTypeDef;

void INTP_Init(INTP_InitTypeDef* Intp_InitStruct);
void INTP_Start(uint16_t pinMsk);
void INTP_Stop(uint16_t pinMsk);
void INTP0_Input_Select(INTP0_InputDef INTP0IN);

#endif
