#ifndef __KEY_INTP_H__
#define __KEY_INTP_H__
#include "common.h"
#include "gpio.h"
#define KEY_WAITTIME                    (1U)   /* change the waiting time according to the system */

#define KR0_INT   0x01
#define KR1_INT   0x02
#define KR2_INT   0x04
#define KR3_INT   0x08
#define KR4_INT   0x10
#define KR5_INT   0x20
#define KR6_INT   0x40
#define KR7_INT   0x80

#define IS_KEY_INT(KEY_INT) (((KEY_INT) == KR0_INT)||((KEY_INT) == KR1_INT)||((KEY_INT) == KR2_INT)||((KEY_INT) == KR3_INT)\
														||((KEY_INT) == KR4_INT)||((KEY_INT) == KR5_INT)||((KEY_INT) == KR6_INT)||((KEY_INT) == KR7_INT))

/*****************************************************************************
The key with the related GPIO:
KR0:PC06
KR1:PC07
KR2:PC12
KR3:PC13
KR4:PC14
KR5:PC15
KR6:PC08
KR7:PC09
*****************************************************************************/

typedef struct
{
	uint8_t INT_Select;     /*!< Specifies the key interrupt trigger source.	*/
	                                        
}KEY_InitTypeDef;


void Key_Start(void);
void Key_Stop(void);
void KEY_Init(KEY_InitTypeDef* Key_InitStruct);

#endif


