/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "adc_demo.h"
#include "cmp_demo.h"
#include "delay_demo.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
	uint32_t msCnt; 	// count value of 1ms
	uint8_t set_value[8];
	uint16_t adcr[8];
	uint16_t avg;
	int i=0,j=0;	
	
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt); 
	delay_init(SystemCoreClock);
	
	Uart0_Init(19200);


	Cmp1_Init();
	CMP_Filter_Setting(CMP_Channel_1, CMP_Filter_None, CMP_IntReq_Rising);	
	CMP_Start(CMP_Channel_1);

	printf("Please apply voltage on the PA02/VCIN12 pin.\n");
	for(i=1; i<8; i++)
	{
		set_value[i] = i * 256 / sizeof(set_value);	
	}
	
	for(i=1; i<sizeof(set_value); i++)
	{
		g_Cmp0IntTaken = 0;		
		CMP_VREF_Set_Value(CMP_Channel_1, set_value[i]);
		delayMS(1);
		for(j=0; j<256; j++) 
		{
			delayMS(1);
			if(g_Cmp0IntTaken) 
			{
				printf("nSide Set Value = 0x%02X, ", CMP->C1RVM);

				printf("C1MON = %d, ", (CMP->COMPMDR & CMP_COMPMDR_C1MON_Msk) >> 7);
				printf("IntTaken = %d\n", g_Cmp0IntTaken);	
				break;
			}
		}		
	}
	while(1)
	{
		;
	}		

}



