#ifndef __LCDPANNEL_H__
#define __LCDPANNEL_H__

#define DMA_CTRL_DATA_LCDB 0

typedef struct
{
	uint8_t x_start;
	uint8_t x_end;
	uint8_t y_start;
	uint8_t y_end;
	uint16_t size;
}ORG_TypeDef;


#define BACKLIGHT_ON() PORT->PSETA = (1<<4)//PA04 
#define BACKLIGHT_OFF() PORT->PCLRA =  (1<<4)//PA04 

#define LCD_CS_HIGH() PORT->PSETA = (1<<10)//PA10//PORT->PSETA = (1<<0)//PA00
#define LCD_CS_LOW() PORT->PCLRA =  (1<<10)//PA10//PORT->PCLRA =  (1<<0)//PA00
#define LCD_RST_HIGH() PORT->PSETA = (1<<2)//PA02//PORT->PSETA = (1<<1)//PA01
#define LCD_RST_LOW() PORT->PCLRA =  (1<<2)//PA02//PORT->PCLRA =  (1<<1)//PA01
#define LCD_DC_HIGH() PORT->PSETD = (1<<0)//PD00//PORT->PSETA = (1<<2)//PA02
#define LCD_DC_LOW() PORT->PCLRD =  (1<<0)//PD00//PORT->PCLRA =  (1<<2)//PA02
#define LCD_WR_HIGH() PORT->PSETC = (1<<11)//PC11
#define LCD_WR_LOW() PORT->PCLRC =  (1<<11)//PC11

#define LCD_W 320
#define LCD_H 240
#define TFT_X_OFFSET 0
#define TFT_Y_OFFSET 0

#define LCD_CMSICON_Pixel 40000
//==================================================================================================================================
void LCDPannel_Init(void);
void Set_Position(uint16_t x1,uint16_t x2,uint16_t y1,uint16_t y2);
void Clear_Display(uint16_t color);
void ShowImage(uint8_t imagenum);




#endif
