/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : lcd_demo.c                                                  *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.16                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "lcd_demo.h"
#include "common.h"
#include "isr.h"

volatile uint32_t lcdbint_cnt;
volatile uint16_t backcolor;
LCDB_Typedef Lcdb;

/**
  * @brief  Demo code of operation about gpio.
  * @param  No parameter.
  * @return void
*/
void LCD_Init(void)
{		
	Lcdb.mode = LCDB_MODE_TYPE_8080;			/* 8080 Mode */
	Lcdb.clock_div = LCDB_CLOCK_DIV_1;		/* 1 divider */
	Lcdb.cycle = LDB_CYCLE_8T;						/* 8T cycles */
	Lcdb.wait_cycle = LDB_WAIT_CYCLE_2T;	/* 2T wait cycles */
	
	LCDB_Init(&Lcdb);
//	ISR_Register(LCDB_IRQn,lcdb_interrupt); 	//LCDжϷ·ע
}

/***********************************************************************************************************************
* Function Name: lcdb_interrupt
* @brief  LCDB interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void lcdb_interrupt(void)
{
    INTC_ClearPendingIRQ(LCDB_IRQn);     /* clear LCDB interrupt flag */
    /* Start user code. Do not edit comment generated here */
	if(++lcdbint_cnt==1)
	{
		Write_LBDATA(backcolor);
	}
	else
	{
		LCD_CS_HIGH();
		
		LCDB_Stop();
	}
	
}

