/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/4/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "CMS32H3201.h"
#include "gpio_demo.h"
#include "lcd_demo.h"
#include "lcdpannel.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t g_ticks;


uint8_t uImage;

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}

int main()
{
	uint32_t msCnt; 	// count value of 1ms

//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt);
	
//-----------------------------------------------------------------------
// initial modules
//----------------------------------------------------------------------- 
	Gpio_Init();
	LCD_Init();
	LCDPannel_Init();
	
	while(1)
	{
		delayMS(1);
		
		ShowImage(uImage);
		
//		Clear_Display(0x00F8);      // RGB 565, L/H Byte
//		delayMS(1000);
//		Clear_Display(0xE007);
//		delayMS(1000);
//		Clear_Display(0x1F00);
//		delayMS(1000);
//		Clear_Display(0xFFFF);
//		delayMS(1000);
//		Clear_Display(0x0000);
	}
}



