/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "common.h"
#include "gpio.h"
#include "cgc.h"
#include "pcbz.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};
 
		SYS_SET_IOCFG(PORT->PA00CFG,GROUP_AF_CLKBUZ0);			// CLKBUZ0  
		SYS_SET_IOCFG(PORT->PA11CFG,GROUP_AF_CLKBUZ1);			// CLKBUZ1  

    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);
	
		PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡclkbuz ͨ0
		PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
		PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_3;	
		PCBZ_Init(&PCBZ_InitStructure);	
	
    /*CLKBUZ1 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_11;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);
	
		PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_1;  //ѡclkbuz ͨ1
		PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FSUB;
		PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FSUB_0;	
		PCBZ_Init(&PCBZ_InitStructure);			
}
int main()
{
	
/*ⲿϵͳʱΪʱ*/
	CGC_LSEConfig(OSC_OSCILLATOR,OSC_NORMAL_POWER);  
	
	PCBZIO_Init();	   
	while(1)
	{
		;
	}

}



