
/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :  
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2019/12/25
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "CMS32H3201.h"
#include "qspi.h"
#include "sci_common.h"
#include "uart_demo.h"
#include "math.h"
#include "stdio.h"
#include "qspi_demo.h"



uint8_t rdata[256];
uint8_t wdata[256];
uint8_t err;

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t g_ticks;

void delayMS(uint32_t n)
{
		g_ticks = n;
		while(g_ticks);
}

int main (void)
{
	uint32_t msCnt; 	// count value of 1ms
	uint32_t i;
	uint32_t div;
	int8_t n;
	
  uint32_t *ptr;	
	
//-----------------------------------------------------------------------
// Systick setting 
//-----------------------------------------------------------------------   
	g_ticks = 1000; 	// 1000ms
	SystemCoreClockUpdate();
	msCnt = SystemCoreClock / 1000;
	SysTick_Config(msCnt);

//-----------------------------------------------------------------------
// Init UART0 for retarget printf/scanf etc. 
//----------------------------------------------------------------------- 
#ifndef RTL_SIMULATION
	Uart0_Init(19200);	
	printf("Hello, UART\n");
	printf("SPI Flash - Erase, Write and Fast Read Quad(EBh)\n");
#endif
	
	QSPI_WriteNorFlash();
	
	QSPI_NorFlash_QUADRead(); //quad read FLASH_ADDR
	QSPI_NorFlash_XIPRead();
	QSPI_NorFlash_ReadSector3();
	QSPI_NorFlash_PrefetchRead();  //prefetch read
	
	while(1)
	{
		;
	}
}


