/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "dma_demo.h"
#include "sspi_demo.h"
#include "gpio_demo.h"
#include "delay_demo.h"


//#define SPI_WITH_DMA
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint8_t mtx_buf1[] = {0xA5, 0x5A, 0xCC, 0x33, 0x3C, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};
uint8_t srx0_buf[13];

int main()
{
    uint32_t msCnt;     // count value of 1ms
    int i = 0, j = 0;
    uint32_t err;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
    Led_Init();

    Spi01_Slave_Init();     //slave mode

#ifdef SPI_WITH_DMA
    Spix1_Slave_Dma_Read(SSPI01,srx0_buf, sizeof(srx0_buf));

    while (g_spi_rx_end == 0);

#else
    Spix1_Int_Read(SSPI01,srx0_buf, sizeof(srx0_buf));

    while (g_spi_rx_end == 0);

#endif
    delayMS(1);

#ifdef SPI_WITH_DMA
    Spix1_Slave_Dma_Write(SSPI01,srx0_buf, sizeof(srx0_buf));

    while (g_spi_tx_end == 0);

    delayMS(2);
#else
    Spix1_Int_Write(SSPI01,srx0_buf, sizeof(srx0_buf));

    while (g_spi_tx_end == 0);

#endif

    delayMS(2);

    err = 0;

    for (i = 0; i < sizeof(srx0_buf); i++)
    {
        if (mtx_buf1[i] != srx0_buf[i])
        {
            err++;
        }
    }

    if (err)
    {
        for (i = 0; i < 8; i++)
        {
            LED_Toggle;
            delayMS(250);
        }

        LED_OFF;
    }
    else
    {
        for (i = 0; i < 8; i++)
        {
            LED_Toggle;
            delayMS(250);
        }

        LED_ON;
    }
}



