/*******************************************************************************
*                  COPYRIGHT (C) 2021 CMS Technologies Ltd.                    *
*                                                                              *
********************************************************************************
* FileName      : spi_demo.c                                                 *
* Author        :                                                              *
* Version       : 1.0                                                          *
* Date          : 2021.08.13                                                   *
* Description   :                                                              *
* Function List :                                                              *
********************************************************************************/
#include "sspi_demo.h"
#include "dma_demo.h"

volatile uint8_t *gp_sspi_rx_address;       /* spi receive buffer address */
volatile uint16_t g_sspi_rx_count;          /* spi receive data count */
/**********************************************************************************************************************/
void NSS01_set()
{
    GPIO_SetBits(GPIO_PORTA, GPIO_Pin_11);
}
void NSS01_clr()
{
    GPIO_ResetBits(GPIO_PORTA, GPIO_Pin_11);
}

void NSS11_set()
{
    GPIO_SetBits(GPIO_PORTC, GPIO_Pin_6);
}
void NSS11_clr()
{
    GPIO_ResetBits(GPIO_PORTC, GPIO_Pin_6);
}

void NSS21_set()
{
    GPIO_SetBits(GPIO_PORTB, GPIO_Pin_2);
}
void NSS21_clr()
{
    GPIO_ResetBits(GPIO_PORTB, GPIO_Pin_2);
}


/***********************************************************************************************************************
* Function Name: Spi01_Init
* @brief	 simple spi init
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi01_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

		GPIO_PinAFConfig(PORT->PA11CFG, GROUP_AF_GPIO);								//config SS01 to PA11
		GPIO_PinAFConfig(PORT->PA12CFG, GROUP_AF_ODEFAULT);						//config MOSI(SDO01) to PA12
		GPIO_PinAFConfig(PORT->PA14CFG, GROUP_AF_ODEFAULT);						//config SCLK_OUTPUT to PA14
		GPIO_PinAFConfig(PORT->PA13CFG, GROUP_AF_ODEFAULT);						//config MISO(SDI01) to PA13
		
    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_11;   						//NSSѡģʽʼʱø/͵ƽΪ
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_14;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_12;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_13;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;             //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;       	//SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;     	//ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;               	//ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;          		//ѡbitȴ

    res = SSPI_Init(SSPI01, &SPI_InitStructure);
//ʹжϷͺͽʱжϷ·
//    ISR_Register(SPI01_IRQn, spi01_interrupt);  //жϷ·ע

    NSSs.Active = NSS01_clr;                            //NSSƬѡʼ
    NSSs.Inactive = NSS01_set;
    NSSs.Inactive();                                  //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    if (res)
    {
        return res;
    }

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi11_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi11_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

		GPIO_PinAFConfig(PORT->PC06CFG, GROUP_AF_GPIO);								//config SS11 to PC06
		GPIO_PinAFConfig(PORT->PC04CFG, GROUP_AF_ODEFAULT);						//config MOSI(SDO11) to PC04
		GPIO_PinAFConfig(PORT->PC03CFG, GROUP_AF_ODEFAULT);						//config SCLK_OUTPUT to PC03
		GPIO_PinAFConfig(PORT->PC05CFG, GROUP_AF_ODEFAULT);						//config MISO(SDI11) to PC05
		
    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_6;   						//NSSѡģʽʼʱø/͵ƽΪ
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTC, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTC, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTC, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTC, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;            //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;        //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;      //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 10000;                //ѡspiʱ 10000
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;            //ѡbitȴ

    res = SSPI_Init(SSPI11, &SPI_InitStructure);

    if (res)
    {
        return res;
    }

    ISR_Register(SPI11_IRQn, spi11_interrupt);  				//жϷ·ע

    NSSs.Active = NSS11_clr;                            //NSSƬѡʼ
    NSSs.Inactive = NSS11_set;
    NSSs.Inactive();                                  	//NSSʼ״̬ MODE0 µ͵ƽΪУclkһز
    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi21_Init
* @brief
* @param   None
* @return
***********************************************************************************************************************/
int8_t Spi21_Init(void)
{
    int8_t res;
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    SPI_InitTypeDef  SPI_InitStructure;

		GPIO_PinAFConfig(PORT->PB02CFG, GROUP_AF_GPIO);								//config SS21 to PB02
		GPIO_PinAFConfig(PORT->PB05CFG, GROUP_AF_ODEFAULT);						//config MOSI(SDO21) to PB05
		GPIO_PinAFConfig(PORT->PB03CFG, GROUP_AF_ODEFAULT);						//config SCLK_OUTPUT to PB03
		GPIO_PinAFConfig(PORT->PB04CFG, GROUP_AF_ODEFAULT);						//config MISO(SDI21) to PB04
		
    /*SS GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_2;   //NSSѡģʽʼʱø/͵ƽΪ
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTB, &GPIO_InitStruct);

    /*SCLK GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_3;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level  = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTB, &GPIO_InitStruct);

    /*SDO(MOSI) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_5;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_HIGH;
    GPIO_Init(GPIO_PORTB, &GPIO_InitStruct);

    /*SDI(MIS0) GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_4;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_IN;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTB, &GPIO_InitStruct);

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;              //SPIģʽ:ΪSPI ģʽSLAVE
    SPI_InitStructure.SPI_DataSize = SPI_Data_Bits_8;          //SPIݴС:SPIͽ8λ֡ṹ
    SPI_InitStructure.SPI_Phase_Mode = SPI_Phase_Mode0;        //ѡʹspiĹģʽ
    SPI_InitStructure.SPI_ClockSpeed = 400000;                 //ѡspiʱ
    SPI_InitStructure.SPI_Bitorder = SPI_Bit_Msb;              //ѡbitȴ

    res = SSPI_Init(SSPI21, &SPI_InitStructure);

    if (res)
    {
        return res;
    }
		//ʹжϷͺͽʱжϷ·
    //  ISR_Register(SPI21_IRQn, spi21_interrupt);       //жϷ·ע

    NSSs.Active = NSS21_clr;                             //NSSƬѡʼ
    NSSs.Inactive = NSS21_set;
    NSSs.Inactive();                                  	 //NSSʼ״̬ MODE0 µ͵ƽΪУclkһز

    return SCI_SUCCESS;
}

/***********************************************************************************************************************
* Function Name: Spi11_Int_Write
* @brief  spi write data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Int_Write(uint8_t *tx_buf, uint16_t tx_num)
{
    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Send);
    SSPI_Start(SSPI11);
    INTC_EnableIRQ(SPI11_IRQn);

    g_spi_tx_end = 0;
    g_spi_rx_end = 0;
    pData.data = tx_buf;    //send buffer pointer
    pData.len  = tx_num;  	//set send data count
    pData.flag = INT_TX;   	//set data direction
    INTC_SetPendingIRQ(SPI11_IRQn);
}


/***********************************************************************************************************************
* Function Name: Spi11_Int_Read
* @brief  spi read data by interrupt,it can be used in the condition of master write or slave write
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Int_Read(uint8_t *rx_buf, uint16_t rx_num)
{

    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Recv);
    SSPI_Start(SSPI11);
    INTC_EnableIRQ(SPI11_IRQn);
		g_spi_rx_end = 0;
    pData.data = rx_buf;   //read buffer pointer
    pData.len  = rx_num;   //set receive data count
    pData.flag = INT_RX;   //set data direction

    SSPI_SendByte(SSPI11, 0xFF);
}

/***********************************************************************************************************************
* Function Name: Spi11_Dma_Write
* @brief  spi write data by dma
* @param  None
* @return None
***********************************************************************************************************************/
void Spi11_Dma_Write(uint8_t *tx_buf, uint16_t tx_num)
{

    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Send);   //ʹд־λ
    SSPI_Start(SSPI11);

    INTC_EnableIRQ(SPI11_IRQn);

    DMA_Sspi_Write(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal, tx_buf, (void *)&SSPI11_SDR, tx_num); //config dma transmission

    pData.flag = INT_DMA;   //set data direction

}

/***********************************************************************************************************************
* Function Name: Spi11_Dma_TxRx
* @brief  SPI peripheral write data and recive data at the same time
* @param   tx_buf: tx_buf to be transmitted by the SPI peripheral
**         tx_num: num to be transmitted
**         rx_buf: received buffer by the SPI peripheral
**         rx_num: received num  by the SPI peripheral
* @return None
***********************************************************************************************************************/
void Spi11_Dma_TxRx(uint8_t *tx_buf, uint16_t tx_num, uint8_t *rx_buf, uint16_t rx_num)
{
	SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_TxRx);

	SSPI_Start(SSPI11);
	g_spi_tx_end = 0;
	g_spi_rx_end = 0;

	DMA_Sspi_WriteRead(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal,tx_buf+1, rx_buf, tx_num-1); //config dma transmission
	pData.flag = INT_DMA;   					//set data type
	pData.data = &rx_buf[rx_num-1];
	SSPI_SendByte(SSPI11, tx_buf[0]); //interrupt triger the dma
}
/***********************************************************************************************************************
* Function Name: Spi11_Dma_Read
* @brief  spi read data by dma
* @param  rx_buf,rx_num
**         rx_buf: received buffer by the SPI peripheral
**         rx_num: received num  by the SPI peripheral
* @return None
***********************************************************************************************************************/
void Spi11_Dma_Read(uint8_t *rx_buf, uint16_t rx_num)
{
    static uint8_t dummy_sio11 = 0xFFU;

    SSPI_Set_TransmitMode(SSPI11, SSPI_TransmitMode_Recv);

    SSPI_Start(SSPI11);
    g_spi_tx_end = 0;
    g_spi_rx_end = 0;	

    DMA_Sspi_Read(DMA_VECTOR_SPI11, CTRL_DATA_SPI11, DMA_Mode_Normal, (void *)&SSPI11_SDR, rx_buf, rx_num - 1); //config dma transmission

    pData.flag = INT_DMA;   //set data type

    pData.data = rx_buf + rx_num - 1;
    SSPI_SendByte(SSPI11, dummy_sio11); //interrupt triger the dma

}

/***********************************************************************************************************************
* Function Name: spi_callback_error
* @brief  SSPI Receive interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi_callback_error()
{
    //user edit here when appear error
}

/***********************************************************************************************************************
* Function Name: spi01_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi01_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SSPI01;

    err_type = SSPI_GetErrStaus(SSPI01, SSPI_FLAG_OVERRUN);

    INTC_ClearPendingIRQ(SPI01_IRQn);


    if (1U == err_type)
    {
        spi_callback_error();//error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    SSPI_SendByte(SSPI01, *pFrame->data);
                    pFrame->data++;
                    pFrame->len--;				
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if ((SSPI_Get_MasterMode(SSPI01) != SPI_Mode_Master) && (SSPI_Get_TransmitMode(SSPI01) != SSPI_TransmitMode_Recv))//slave mode :sclk is inputed by master clk
                    {
                        ;// when in slave mode ,do not need to wait end
                    }
                    else
                    {
                        while (SSPI_GetErrStaus(SSPI01, SCI_UNDER_EXECUTE)); //waitting conmunction end, if register ST turns 1,or SS turns 1
                    }
                }

                SSPI_Stop(func);
                g_spi_tx_end = 1;
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI01);
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI01);
                }

                if (SSPI_Get_MasterMode(SSPI01) == SPI_Mode_Master)
                {
                    SSPI_SendByte(SSPI01, 0xFF);                   // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {

                while (SSPI_GetErrStaus(SSPI01, SCI_VALID_STORED) == 0); // wait last data stored in register SDR

                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI01);
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI01);
                }

                SSPI_Stop(func);
                g_spi_rx_end = 1;
            }
        }

        if (pFrame->flag == INT_DMA)
        {
            SSPI_Stop(func);
            g_spi_tx_end = 1;
            g_spi_rx_end = 1;
        }
    }
}




/***********************************************************************************************************************
* Function Name: spi11_interrupt
* @brief  spi write/read interrupt service routine
* @param  None
* @return None
***********************************************************************************************************************/
void spi11_interrupt(void *msg)
{
    volatile uint8_t err_type;
    volatile uint8_t sio_dummy;
    ATE_FRAME_t *pFrame = (ATE_FRAME_t *)msg;
    SCIAFSelect_TypeDef func = SSPI11;

    err_type = SSPI_GetErrStaus(SSPI11, SSPI_FLAG_OVERRUN);

    INTC_ClearPendingIRQ(SPI11_IRQn);

    if (1U == err_type)
    {
        spi_callback_error();//error condition
    }
    else
    {
        if (pFrame->flag == INT_TX)
        {
            if (pFrame->len > 0)
            {
                if (0U != pFrame->data)
                {
                    SSPI_SendByte(SSPI11, *pFrame->data);
                    pFrame->data++;
                    pFrame->len--;				
                }
            }
            else
            {
                if (0U != pFrame->data)
                {
                    if ((SSPI_Get_MasterMode(SSPI11) != SPI_Mode_Master) && (SSPI_Get_TransmitMode(SSPI11) != SSPI_TransmitMode_Recv))//slave mode :sclk is inputed by master clk
                    {
                        ;//slave mode;
                    }
                    else
                    {
                        while (SSPI_GetErrStaus(SSPI11, SCI_UNDER_EXECUTE)); //waitting conmunction end, if register ST turns 1,or SS turns 1
                    }
                }

                SSPI_Stop(func);
                g_spi_tx_end = 1;
            }
        }

        if (pFrame->flag == INT_RX)
        {
            if (pFrame->len > 1)
            {
                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI11);
                    pFrame->data++;
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI11);
                }

                if (SSPI_Get_MasterMode(SSPI11) == SPI_Mode_Master)
                {
                    SSPI_SendByte(SSPI11, 0xFFU);  // dummy write in master reception mode
                }
            }
            else if (pFrame->len == 1)
            {
//                while (SSPI_GetErrStaus(SSPI11, SCI_VALID_STORED) == 0); // wait last data stored in register SDR

                if (0U != pFrame->data)
                {
                    *pFrame->data = SSPI_ReceiveByte(SSPI11);
                    pFrame->len--;
                }
                else
                {
                    sio_dummy = SSPI_ReceiveByte(SSPI11);
                }

                SSPI_Stop(func);
                g_spi_rx_end = 1;
            }
        }

        if (pFrame->flag == INT_DMA)
        {
#ifdef 	SPI_WITH_DMA					
			while (SSPI_GetErrStaus(SSPI11, SCI_VALID_STORED) == 0); // wait last data stored in register SDR
#endif					
			*pFrame->data = SSPI_ReceiveByte(SSPI11);
			
            SSPI_Stop(func);
            g_spi_tx_end = 1;
            g_spi_rx_end = 1;
        }
    }
}
