/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "gpio_demo.h"
#include "uart_demo.h"
#include "tim_demo.h"
#include "delay_demo.h"
#include "pcbz.h"
#include "CMS32H3201.h"


/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
uint32_t fCLK_Parameter;

void PCBZIO_Init()
{
    GPIO_InitTypeDef GPIO_InitStruct = {0};
    PCBZ_InitTypeDef PCBZ_InitStructure = {0};
		
		GPIO_PinAFConfig(PORT->PA00CFG, GROUP_AF_CLKBUZ0);					//PCLBUZ0 is fixed to PA00
		
    /*CLKBUZ0 GPIO CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl   = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTA, &GPIO_InitStruct);

		PCBZ_InitStructure.PCBZ_ChanSelect = PCBZ_CHANNEL_0;  //ѡPCLBUZͨ0
		PCBZ_InitStructure.PCBZ_ClkSource =  PCBZ_FMAIN;
		PCBZ_InitStructure.PCBZ_Freqscaler = PCBZ_FMAIN_3;
		
		PCBZ_Init(&PCBZ_InitStructure);	
		
		fCLK_Parameter = SystemCoreClock/(0x01 << PCBZ_InitStructure.PCBZ_Freqscaler);
}

int main()
{
    uint32_t msCnt;     // count value of 1ms
    uint32_t width = 0;
		float time = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
    delay_init(SystemCoreClock);
		
		PCBZIO_Init();

    Uart0_Init(19200);

    /*Example8:Tim8 get external wave pluse widthpulse period*/	
#if 1
		Tim8_GetPulsePeriod_Init();

		while(1)
		{
			width = TIM_GetPulseWidth(TIM8,TTM_Channel_0);
			printf("PC07/TI10 pulse width  = %d fCLK\n", width);  /* expected value: msCnt */	
		}
#endif
}




