/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "gpio_demo.h"
#include "wdt.h"
#include "dma_demo.h"
#include "delay_demo.h"

//#define UART0_DMA_RCV
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt, len;    // count value of 1ms
    uint32_t i,j;
    uint8_t rxbuf[64];
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
	
		Uart0_Init(230400);
		UART_DeInit(UART0);
		Uart0_Init(115200);
	
#ifdef UART0_DMA_RCV
    /*0ͨDMAղ*/
    DMA_Uart0_Rx(DMA_VECTOR_SR0, DMA_Mode_Repeat, (void *)&UART0_RX, UART0_RX_BUF, UART_MAX_RECV_LEN); //config dma transmission
		i = Uart0_Receive();
#endif
    printf("Hello, UART\n");

#ifdef UART0_DMA_RCV
/***ʱΪDMAת**/
			for (i = 0;i<65530;i++)
			{
				for(j=0;j<1000;j++)//1000
				{
					;
				}
			}
			len = Uart0_Dma_Rcv(rxbuf);

			if (len)
			{
					Uart0_Dma_Send(rxbuf, (len-1));
			}
#endif			


		
		 while (1)
    {
#ifndef UART0_DMA_RCV

        if (UART0_RX_STA & 0x8000U)
        {
            for (i = 0; i < (UART0_RX_STA & 0x7f); i++)   //ѯ
            {
                Uart0_Send(UART0_RX_BUF[i]);
            }

            UART0_RX_STA = 0;
        }

#endif
    }
}




