/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32H3201
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "gpio_demo.h"
#include "wdt.h"
#include "dma_demo.h"
#include "delay_demo.h"

//#define UART2_DMA_RCV
/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt, len;    // count value of 1ms
    uint32_t i,j;
    uint8_t rxbuf[64];
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
	
		Uart2_Init(230400);
		UART_DeInit(UART2);
		Uart2_Init(115200);
	
#ifdef UART2_DMA_RCV
    /*2ͨDMAղ*/
    DMA_Uart_Rx(DMA_VECTOR_SR2, DMA_Mode_Repeat, (void *)&UART2_RX, UART2_RX_BUF, UART_MAX_RECV_LEN); //config dma transmission
		i = Uart2_Receive();
#endif
    printf("Hello, UART\n");

#ifdef UART2_DMA_RCV
/***ʱΪDMAת**/
			for (i = 0;i<65530;i++)
			{
				for(j=0;j<1000;j++)
				{
					;
				}
			}
			len = Uart2_Dma_Rcv(rxbuf);

			if (len)
			{
					Uart2_Dma_Send(rxbuf, (len-1));
			}

#endif			


		
		 while (1)
    {
#ifndef UART2_DMA_RCV

        if (UART2_RX_STA & 0x8000U)
        {

            for (i = 0; i < (UART2_RX_STA & 0x7f); i++)   //ѯ
            {
                Uart2_Send(UART2_RX_BUF[i]);
            }

            UART2_RX_STA = 0;
        }

#endif
    }
}




